---
title: Debugger.Memory
slug: Tools/Debugger-API/Debugger.Memory
---
<div>{{ToolsSidebar}}</div>

<h1 id="Debugger.Memory">Debugger.Memory</h1>

<p>The <a href="../Debugger-API" title="The Debugger API"><code>Debugger API</code></a> can help tools observe the debuggee’s memory use in various ways:</p>

<ul>
 <li>
  <p>It can mark each new object with the JavaScript call stack at which it was allocated.</p>
 </li>
 <li>
  <p>It can log all object allocations, yielding a stream of JavaScript call stacks at which allocations have occurred.</p>
 </li>
 <li>
  <p>It can compute a <em>census</em> of items belonging to the debuggee, categorizing items in various ways, and yielding item counts.</p>
 </li>
</ul>

<p>If<em>dbg</em> is a <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance, then the methods and accessor properties of <code><em>dbg</em>.memory</code> control how<em>dbg</em> observes its debuggees’ memory use. The <code><em>dbg</em>.memory</code> object is an instance of <code>Debugger.Memory</code>; its inherited accesors and methods are described below.</p>

<h3 id="Allocation_Site_Tracking">Allocation Site Tracking</h3>

<p>The JavaScript engine marks each new object with the call stack at which it was allocated, if:</p>

<ul>
 <li>
  <p>the object is allocated in the scope of a global object that is a debuggee of some <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance<em>dbg</em>; and</p>
 </li>
 <li>
  <p><code><em>dbg</em>.memory.<a href="Debugger.Memory#trackingallocationsites" title="Debugger.Memory: trackingAllocationSites">trackingAllocationSites</a></code> is set to <code>true</code>.</p>
 </li>
 <li>
  <p>A <a href="https://en.wikipedia.org/wiki/Bernoulli_trial" title="Bernoulli Trial">Bernoulli trial</a> succeeds, with probability equal to the maximum of <a href="Debugger.Memory#alloc-sampling-probability" title="Debugger.Memory: allocationSamplingProbability"><code>d.memory.allocationSamplingProbability</code></a> of all <code>Debugger</code> instances <code>d</code> that are observing the global that this object is allocated within the scope of.</p>
 </li>
</ul>

<p>Given a <a href="Debugger.Object"><code>Debugger.Object</code></a> instance<em>dobj</em> referring to some object, <code><em>dobj</em>.<a href="Debugger.Object#allocationsite" title="Debugger.Object: allocationSite">allocationSite</a></code> returns a <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey/SavedFrame" title="SavedFrame">saved call stack</a> indicating where<em>dobj</em>’s referent was allocated.</p>

<h3 id="Allocation_Logging">Allocation Logging</h3>

<p>If<em>dbg</em> is a <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance, and <code><em>dbg</em>.memory.<a href="Debugger.Memory#trackingallocationsites" title="Debugger.Memory: trackingAllocationSites">trackingAllocationSites</a></code> is set to <code>true</code>, then the JavaScript engine logs each object allocated by<em>dbg</em>’s debuggee code. You can retrieve the current log by calling <code><em>dbg</em>.memory.<a href="Debugger.Memory#drain-alloc-log" title="Debugger.Memory: drainAllocationsLog">drainAllocationsLog</a></code>. You can control the limit on the log’s size by setting <code><em>dbg</em>.memory.<a href="Debugger.Memory#max-alloc-log" title="Debugger.Memory: maxAllocationsLogLength">maxAllocationsLogLength</a></code>.</p>

<h3 id="Censuses">Censuses</h3>

<p>A <em>census</em> is a complete traversal of the graph of all reachable memory items belonging to a particular <code>Debugger</code>‘s debuggees. It produces a count of those items, broken down by various criteria. If<em>dbg</em> is a <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance, you can call <code><em>dbg</em>.memory.<a href="Debugger.Memory#take-census" title="Debugger.Memory: takeCensus">takeCensus</a></code> to conduct a census of its debuggees’ possessions.</p>

<h2 id="Accessor_Properties_of_the_Debugger.Memory.prototype_Object">Accessor Properties of the <code>Debugger.Memory.prototype</code> Object</h2>

<p>If<em>dbg</em> is a <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance, then <code>&lt;i&gt;dbg&lt;/i&gt;.memory</code> is a <code>Debugger.Memory</code> instance, which inherits the following accessor properties from its prototype:</p>

<dl>
 <dt><code id="trackingallocationsites">trackingAllocationSites</code></dt>
 <dd>
 <p>A boolean value indicating whether this <code>Debugger.Memory</code> instance is capturing the JavaScript execution stack when each Object is allocated. This accessor property has both a getter and setter: assigning to it enables or disables the allocation site tracking. Reading the accessor produces <code>true</code> if the Debugger is capturing stacks for Object allocations, and <code>false</code> otherwise. Allocation site tracking is initially disabled in a new Debugger.</p>

 <p>Assignment is fallible: if the Debugger cannot track allocation sites, it throws an <code>Error</code> instance.</p>

 <p>You can retrieve the allocation site for a given object with the <a href="Debugger.Object#allocationsite" title="Debugger.Object: allocationSite"><code>Debugger.Object.prototype.allocationSite</code></a> accessor property.</p>
 </dd>
 <dt><code id="alloc-sampling-probability">allocationSamplingProbability</code></dt>
 <dd>
 <p>A number between 0 and 1 that indicates the probability with which each new allocation should be entered into the allocations log. 0 is equivalent to “never”, 1 is “always”, and .05 would be “one out of twenty”.</p>

 <p>The default is 1, or logging every allocation.</p>

 <p>Note that in the presence of multiple <code>Debugger</code> instances observing the same allocations within a global’s scope, the maximum <code>allocationSamplingProbability</code> of all the <code>Debugger</code>s is used.</p>
 </dd>
 <dt><code id="max-alloc-log">maxAllocationsLogLength</code></dt>
 <dd>The maximum number of allocation sites to accumulate in the allocations log at a time. This accessor can be both fetched and stored to. Its default value is <code>5000</code>.</dd>
 <dt><code id="allocationsLogOverflowed">allocationsLogOverflowed</code></dt>
 <dd>Returns <code>true</code> if there have been more than [<code>maxAllocationsLogLength</code>][#max-alloc-log] allocations since the last time [<code>drainAllocationsLog</code>][#drain-alloc-log] was called and some data has been lost. Returns <code>false</code> otherwise.</dd>
</dl>

<h2 id="Debugger.Memory_Handler_Functions">Debugger.Memory Handler Functions</h2>

<p>Similar to <a href="../Debugger-API" title="The Debugger API"><code>Debugger</code>’s handler functions</a>, <code>Debugger.Memory</code> inherits accessor properties that store handler functions for SpiderMonkey to call when given events occur in debuggee code.</p>

<p>Unlike <code>Debugger</code>‘s hooks, <code>Debugger.Memory</code>’s handlers’ return values are not significant, and are ignored. The handler functions receive the <code>Debugger.Memory</code>’s owning <code>Debugger</code> instance as their <code>this</code> value. The owning <code>Debugger</code>’s <code>uncaughtExceptionHandler</code> is still fired for errors thrown in <code>Debugger.Memory</code> hooks.</p>

<p>On a new <code>Debugger.Memory</code> instance, each of these properties is initially <code>undefined</code>. Any value assigned to a debugging handler must be either a function or <code>undefined</code>; otherwise a <code>TypeError</code> is thrown.</p>

<p>Handler functions run in the same thread in which the event occurred. They run in the compartment to which they belong, not in a debuggee compartment.</p>

<dl>
 <dt><code>onGarbageCollection(<em>statistics</em>)</code></dt>
 <dd>
 <p>A garbage collection cycle spanning one or more debuggees has just been completed.</p>

 <p>The <em>statistics</em> parameter is an object containing information about the GC cycle. It has the following properties:</p>

 <dl>
  <dt><code>collections</code></dt>
  <dd>
  <p>The <code>collections</code> property’s value is an array. Because SpiderMonkey’s collector is incremental, a full collection cycle may consist of multiple discrete collection slices with the JS mutator running interleaved. For each collection slice that occurred, there is an entry in the <code>collections</code> array with the following form:</p>

  <pre class="language-js notranslate"><code>
{
  "startTimestamp":<em>timestamp</em>,
  "endTimestamp":<em>timestamp</em>,
}
</code></pre>

  <p>Here the <em>timestamp</em> values are <a href="Conventions#timestamps" title="Debugger API: General Conventions: Timestamps">timestamps</a> of the GC slice’s start and end events.</p>
  </dd>
  <dt><code>reason</code></dt>
  <dd>
  <p>A very short string describing the reason why the collection was triggered. Known values include the following:</p>

  <ul>
   <li>“API”</li>
   <li>“EAGER_ALLOC_TRIGGER”</li>
   <li>“DESTROY_RUNTIME”</li>
   <li>“LAST_DITCH”</li>
   <li>“TOO_MUCH_MALLOC”</li>
   <li>“ALLOC_TRIGGER”</li>
   <li>“DEBUG_GC”</li>
   <li>“COMPARTMENT_REVIVED”</li>
   <li>“RESET”</li>
   <li>“OUT_OF_NURSERY”</li>
   <li>“EVICT_NURSERY”</li>
   <li>“FULL_STORE_BUFFER”</li>
   <li>“SHARED_MEMORY_LIMIT”</li>
   <li>“PERIODIC_FULL_GC”</li>
   <li>“INCREMENTAL_TOO_SLOW”</li>
   <li>“DOM_WINDOW_UTILS”</li>
   <li>“COMPONENT_UTILS”</li>
   <li>“MEM_PRESSURE”</li>
   <li>“CC_WAITING”</li>
   <li>“CC_FORCED”</li>
   <li>“LOAD_END”</li>
   <li>“PAGE_HIDE”</li>
   <li>“NSJSCONTEXT_DESTROY”</li>
   <li>“SET_NEW_DOCUMENT”</li>
   <li>“SET_DOC_SHELL”</li>
   <li>“DOM_UTILS”</li>
   <li>“DOM_IPC”</li>
   <li>“DOM_WORKER”</li>
   <li>“INTER_SLICE_GC”</li>
   <li>“REFRESH_FRAME”</li>
   <li>“FULL_GC_TIMER”</li>
   <li>“SHUTDOWN_CC”</li>
   <li>“USER_INACTIVE”</li>
  </ul>
  </dd>
  <dt><code>nonincrementalReason</code></dt>
  <dd>
  <p>If SpiderMonkey’s collector determined it could not incrementally collect garbage, and had to do a full GC all at once, this is a short string describing the reason it determined the full GC was necessary. Otherwise, <code>null</code> is returned. Known values include the following:</p>

  <ul>
   <li>“GC mode”</li>
   <li>“malloc bytes trigger”</li>
   <li>“allocation trigger”</li>
   <li>“requested”</li>
  </ul>
  </dd>
  <dt><code>gcCycleNumber</code></dt>
  <dd>The GC cycle’s “number”. Does not correspond to the number of GC cycles that have run, but is guaranteed to be monotonically increasing.</dd>
 </dl>
 </dd>
</dl>

<h2 id="Function_Properties_of_the_Debugger.Memory.prototype_Object">Function Properties of the <code>Debugger.Memory.prototype</code> Object</h2>

<h2 id="Memory_Use_Analysis_Exposes_Implementation_Details"><em><em>Memory Use Analysis Exposes Implementation Details</em></em></h2>

<p>Memory analysis may yield surprising results, because browser implementation details that are transparent to content JavaScript often have visible effects on memory consumption. Web developers need to know their pages’ actual memory consumption on real browsers, so it is correct for the tool to expose these behaviors, as long as it is done in a way that helps developers make decisions about their own code.</p>

<p>This section covers some areas where Firefox’s actual behavior deviates from what one might expect from the specified behavior of the web platform.</p>

<h3 id="Objects">Objects</h3>

<p>SpiderMonkey objects usually use less memory than the naïve “table of properties with attributes” model would suggest. For example, it is typical for many objects to have identical sets of properties, with only the properties’ values varying from one object to the next. To take advantage of this regularity, SpiderMonkey objects with identical sets of properties may share their property metadata; only property values are stored directly in the object.</p>

<p>Array objects may also be optimized, if the set of live indices is dense.</p>

<h3 id="Strings">Strings</h3>

<p>SpiderMonkey has three representations of strings:</p>

<ul>
 <li>
  <p>Normal: the string’s text is counted in its size.</p>
 </li>
 <li>
  <p>Substring: the string is a substring of some other string, and points to that string for its storage. This representation may result in a small string retaining a very large string. However, the memory consumed by the string itself is a small constant independent of its size, since it is a reference to the larger string, a start position, and a length.</p>
 </li>
 <li>
  <p>Concatenations: When asked to concatenate two strings, SpiderMonkey may elect to delay copying the strings’ data, and represent the result as a pointer to the two original strings. Again, such a string retains other strings, but the memory consumed by the string itself is a small constant independent of its size, since it is a pair of pointers.</p>
 </li>
</ul>

<p>SpiderMonkey converts strings from the more complex representations to the simpler ones when it pleases. Such conversions usually increase memory consumption.</p>

<p>SpiderMonkey shares some strings amongst all web pages and browser JS. These shared strings, called <em>atoms</em>, are not included in censuses’ string counts.</p>

<h3 id="Scripts">Scripts</h3>

<p>SpiderMonkey has a complex, hybrid representation of JavaScript code. There are four representations kept in memory:</p>

<ul>
 <li>
  <p><em>Source code</em>. SpiderMonkey retains a copy of most JavaScript source code.</p>
 </li>
 <li>
  <p><em>Compressed source code</em>. SpiderMonkey compresses JavaScript source code, and de-compresses it on demand. Heuristics determine how long to retain the uncompressed code.</p>
 </li>
 <li>
  <p><em>Bytecode</em>. This is SpiderMonkey’s parsed representation of JavaScript. Bytecode can be interpreted directly, or used as input to a just-in-time compiler. Source is parsed into bytecode on demand; functions that are never called are never parsed.</p>
 </li>
 <li>
  <p><em>Machine code</em>. SpiderMonkey includes several just-in-time compilers, each of which translates JavaScript source or bytecode to machine code. Heuristics determine which code to compile, and which compiler to use. Machine code may be dropped in response to memory pressure, and regenerated as needed.</p>
 </li>
</ul>

<p>Furthermore, SpiderMonkey tracks which types of values have appeared in variables and object properties. This type information can be large.</p>

<p>In a census, all the various forms of JavaScript code are placed in the <code>"script"</code> category. Type information is accounted to the <code>"types"</code> category.</p>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dd>js/src/doc/Debugger/Debugger.Memory.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:2c1529d6932efec8c624a6f1f366b09cb7fce625a6468657fab81788240bc7ae</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/e91b2c85aacd">e91b2c85aacd</a></dd>
</dl>
